/*
 * Copyright (c) 2009, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#include <asm/nios2-io.h>
#include <asm/mmap.h>

int gpio_init(unsigned int base)
{
   alt_pio_t* pio;
   pio = (alt_pio_t*)base;

   pio -> direction = 0x00;        /* input */
   pio -> interruptmask = 0x00;    /* no irq */
      
   return 0;
}

int gpio_direction_input(unsigned int gpio, unsigned int base)
{
   alt_pio_t* pio;
   pio = (alt_pio_t*)base;

   if(gpio<0 || gpio>32) return -1;

   pio -> direction &= ~(1 << gpio);

   return 0;
}

int gpio_direction_output(unsigned int gpio, unsigned int base)
{
   alt_pio_t* pio;
   pio = (alt_pio_t*)base;

   if(gpio<0 || gpio>32) return -1;

   pio -> direction |= 1 << gpio;

   return 0;
}

int gpio_get_value(unsigned int gpio, unsigned int base)
{
   alt_pio_t* pio;

   pio = (alt_pio_t*)base;

   if(gpio<0 || gpio>32) return -1;
   
   return ((pio -> data) >> gpio) & 0x0001;
}

int gpio_set_value(unsigned int gpio, int value, unsigned int base)
{
   alt_pio_t* pio;

   pio = (alt_pio_t*)base;

   if(gpio<0 || gpio>32) return -1;

   if(value){
      pio -> data |= 1 << gpio;
   }else{
      pio -> data &= ~(1 << gpio);
   }
}

