/*
 * Copyright (c) 2009, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#ifndef __I2C_GPIO_H__
#define __I2C_GPIO_H__

#include <asm/mmap.h>

#define I2C_IO_DIR_IN  0
#define I2C_IO_DIR_OUT 1

#define I2C_CTRL_RD 1
#define I2C_CTRL_WR 0

#define I2C_ACK    1
#define I2C_NOACK 0

typedef struct i2c_gpio_channel_data{
   unsigned int gpio_base;
   unsigned int scl_pin;
   unsigned int sda_pin;
   int udelay;
   int timeout;
} i2c_gpio_channel_data_t;

extern void i2c_set_channel(i2c_gpio_channel_data_t* i2c_d);

extern void i2c_start(void);
extern void i2c_stop(void);

extern int i2c_read_byte(int ack);
extern int i2c_write_byte(int value);
extern int i2c_set_ctrl(int value, int mode);

#endif /* __I2C_GPIO_H__ */

