/*
 * Copyright (c) 2009, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#include <asm/nios2-io.h>
#include "serial.h"

/*
 * TODO
 *
 * - multi serial dev management.
 * - baudrate setting when available.
 */

void uart_putc(int base, char c)
{
   alt_uart_t* uart;

   #ifdef VT100_CR
      if (c == '\n')
         uart_putc(base, '\r');
   #endif
   
   uart = (alt_uart_t*)base;
   
   while (((uart -> status) & ALT_UART_TRDY) == 0);
   
   uart -> txdata = (unsigned char)c;
}

void jtag_putc(int base, char c)
{
   alt_jtag_uart_t* jtag;

   jtag = (alt_jtag_uart_t*)base;

   while (!((jtag -> control) & ALT_JTAG_UART_WSPACE));

   jtag -> data = (unsigned char)c;
}

/*
char jtag_getc(int base)
{
   alt_jtag_uart_t* jtag;
   unsigned int val;
   
   jtag = (alt_jtag_uart_t*)base;
   
   while (1){
      val = (jtag -> data);
      if( val & ALT_JTAG_UART_RVALID )
         break;
   }

   return (char)(val & NIOS_JTAG_DATA);
}
*/

