/*
 * Copyright (c) 2009, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

/* TODO clean this code ;-) */

#include "font_8x8.c"
#include "fbcon.h"

#include <sysutil.h>

#include <asm/mmap.h>
// #include <asm/cache.h>
// #include <timer.h>

// #include <dma.h>

#include <irq.h>
#include <timer.h>

/* 8x8 font */
#define font_w 8
#define font_h 8

struct term {
   int x_max_chr;
   int y_max_chr;
   int cursor_x;
   int cursor_y;
   int cursor_visible;
   int cursor_locked;
};

struct fb {
   int width;
   int height;
   unsigned int* base;
};

static struct fb mmapfb;
volatile static struct term fbterm; /* needed inside an irq routine */

static int dma_lock = 0;

static void toggle_cursor(void)
{
   alt_timer_irqclr(IO_TIMER_01_BASE | 0x80000000);

   if(fbterm.cursor_locked) return;

   if(fbterm.cursor_visible)
   {
      charblt(0x00, fbterm.cursor_x, fbterm.cursor_y);
      fbterm.cursor_visible = 0;
   }else{
      charblt(0xdb, fbterm.cursor_x, fbterm.cursor_y);
      fbterm.cursor_visible = 1;
   }
}

inline void putpxl(int x, int y)
{
   mmapfb.base[(mmapfb.width * y)+x]=(unsigned int)0xffffffff;
}

/* for 32bits fb */

int charblt(int c, int col, int row)
{
	int i,j;
   volatile unsigned short * offs; /* d-cache bypass */
   volatile unsigned short * offe; /* d-cache bypass */

   offs=mmapfb.base;
   offs+=(mmapfb.width*((++row<<3)-1))+(col<<3)-1;

   i=8;

	while(i--)
	{
      offe=offs+8; j=0;
      while(offe - offs)
		{
         if ( (*(fontdata_8x8+((c<<3)+i)) >> j++) & 0x01 ) {
            *offe--=(unsigned short)0xffff;
         }else{
            *offe--=(unsigned short)0x0000;
         }
      }
      offs-=mmapfb.width;
	}

/*
   offs=mmapfb.base;
   offs+=(mmapfb.width*(row<<3))+(col<<3);

	for(i=0; i<8; i++)
	{
      offe=offs+8; j=0;
      while(offe - offs)
		{
         if ( (*(fontdata_8x8+((c<<3)+i)) >> ++j) & 0x01 ) {
            *offe--=(unsigned int)0xffffffff;
         }else{
            *offe--=(unsigned int)0xff000000;
         }
      }
      offs+=mmapfb.width;
	}
*/
  
  return 0;
}

void fbhscroll(void)
{
   unsigned int *ps, *pe;
   unsigned long count;


   ps = mmapfb.base; 
   pe = ps + ((mmapfb.width << 3) / 2);
   count = (mmapfb.width * (mmapfb.height - font_h)) / 2;
   
   while(count--) *ps++ = *pe++;

/*   
   dma_memcpy(((unsigned int)mmapfb.base) + (mmapfb.width<<2) * font_h,
         (unsigned int)mmapfb.base,
         ((mmapfb.width<<2) * font_h) * (mmapfb.height / font_h) );
  
   dma_memcpy(((unsigned int)mmapfb.base) + (mmapfb.width << 5),
         (unsigned int)mmapfb.base,
         (mmapfb.width << 5) * 34 );
*/
  
   /* blank last line */

   ps = (unsigned int *)((unsigned int)mmapfb.base + ( ((mmapfb.width << 5) * 33) / 2));

   count = (mmapfb.width << 2); /* mmapfb.width * 4 */

   while(count--) *ps++ = 0x00000000; 

   /* flush_dcache(); */
}

/* channel interface wrapper */
int fbputc(int base, char c)
{
   return fbputchar((int)c);
}

int fbputchar(int c)
{
   /* special char / TODO replace by real term emulation */

   fbterm.cursor_locked = 1;
   
   switch(c){
      case '\r':
         fbterm.cursor_x = 0;
         charblt(0x00, fbterm.cursor_x, fbterm.cursor_y);   /* cursor */
         break;
      case '\n':
         charblt(0x00, fbterm.cursor_x, fbterm.cursor_y);   /* cursor */
         fbterm.cursor_x = 0;
         fbterm.cursor_y++;
         break;
      default:
         charblt(c, fbterm.cursor_x++, fbterm.cursor_y);
         break;
   }

   /* check for borders */

   if (fbterm.cursor_x == fbterm.x_max_chr) {
      fbterm.cursor_x = 0;
      fbterm.cursor_y++;      
   }

   if (fbterm.cursor_y == fbterm.y_max_chr) {
      fbhscroll();
      fbterm.cursor_y--;
   }

   charblt(0xdb, fbterm.cursor_x, fbterm.cursor_y);   /* cursor */

   fbterm.cursor_locked = 0;

   return (int)c;
}

int fbputs(char* str)
{
	int i=0;

	while(str[i])
	{
		/* charblt(str[i], fbterm.cursor_x++, fbterm.cursor_y); */
      fbputchar(str[i]);
      i++; /* if (i>80) break; */
	}
   
	return 0;
}

int fbcon_init(unsigned int base, int width, int height)
{
   /* TODO check if width/height are ok */

   mmapfb.width = width;
   mmapfb.height = height;
   mmapfb.base = base;

   fbterm.x_max_chr = width / font_w;
   fbterm.y_max_chr = height / font_h;

   fbterm.cursor_x = 0;
   fbterm.cursor_y = 0;
   fbterm.cursor_visible = 0;
   fbterm.cursor_locked = 0;

   /* cursor blink */

   alt_timer_init(IO_TIMER_01_BASE | 0x80000000, SYS_CLK_FREQ, 250);
   irq_register(IO_TIMER_01_IRQ, (irq_handler_t*)toggle_cursor, 0x00);
   alt_timer_start(IO_TIMER_01_BASE | 0x80000000);
  
   return 0;
}

