/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#ifndef __MMAP_H__
#define __MMAP_H__

/************************************************************/

/* cpu */

#define CPU_ICACHE_SIZE       4096        /* 4 KByte total	*/
#define CPU_ICACHELINE_SIZE   32          /* 32 bytes/line	*/

#define CPU_DCACHE_SIZE       4096        /* 4 KByte */
#define CPU_DCACHELINE_SIZE   32          /* 32 bytes/line */

#define SYS_EXEC_BASE         0x01008000  /* execution base */
#define SYS_INIT_SP           0x017fff00  /* stack base */
#define SYS_EX_VECTOR         0x01000020  /* exceptions entry point */

#define SYS_CLK_FREQ          50000000    /* 50Mhz */

/************************************************************/

/* memories */

#define MEM_NOR_FLASH_BASE    0xXXXXXXXX  /* FLASH base addr */
#define MEM_NOR_FLASH_SIZE    0xXXXXXXXX  /* xx MByte(s) */
#define MEM_DRAM_BASE         0x01000000  /* DRAM base addr */
#define MEM_DRAM_SIZE         0xXXXXXXXX  /* xx MByte(s) */
#define MEM_SRAM_BASE         0xXXXXXXXX  /* SRAM base addr */
#define MEM_SRAM_SIZE         0xXXXXXXXX  /* xx kBytes */

/************************************************************/

/* peripherals */

#define IO_TIMER_00_BASE      0x02000900
#define IO_TIMER_00_IRQ       0x02

#define IO_TIMER_01_BASE      0x02000920
#define IO_TIMER_01_IRQ       0x03

#define IO_MM_GFX_BASE        0x02000800
#define IO_MM_GFX_IRQ         0x00

/* graphics */

#define MEM_GFX_P1_BASE       0xXXXXXXXX  /* xxx*xxx*xxbpp */
#define MEM_GFX_P2_BASE       0xXXXXXXXX  /* xxx*xxx*xxbpp */
#define MEM_GFX_P3_BASE       0xXXXXXXXX  /* xxx*xxx*xxbpp */

/************************************************************/

/* console */

#define IO_DFLT_UART          0xXXXXXXXX

#endif   /* __MMAP_H__ */
 
